﻿using System;

namespace Orz.Framework.Core.Subscriber
{
    /// <summary>
    /// The interface of subscriber.
    /// </summary>
    public interface ISubscriber : IDisposable
    {
        /// <summary>
        /// Subscribe the message handler.
        /// </summary>
        void Subscribe();

        /// <summary>
        /// Handle a message.
        /// </summary>
        /// <param name="message">The message.</param>
        void Handle(object message);
    }
}
